# Copyright (c) 2008-2009 Code Lounge.
# See LICENSE for details

from twisted.application import service, internet

from axiom.store import Store

from gina.controller import GinaController
from gina.protocol import JabberFactory, JabberProtocol
from gina.igina import ICommand

from gina.plugin import loadPlugins

def deploy(config):
    application = service.Application('Gina')
    
    store = Store('gina.axiom')
    
    def ctrlFactory(protocol):
        ctrl = GinaController(store, protocol, config)
        loadPlugins(ctrl, store)
        return ctrl

    gina = internet.TCPClient(config['SERVER'], 5222, JabberFactory(ctrlFactory, JabberProtocol, config))
    gina.setServiceParent(application)

    return application
