# Copyright (c) 2008-2009 Code Lounge.
# See LICENSE for details

from twisted.python import log
from twisted.internet import reactor, utils

from gina.plugin import PluginMixin
from gina.controller import PseudoHandler

from gina.util import usage

class Dns(PseudoHandler, PluginMixin):
    help = '<b>[DNS Help]</b>'
    pluginName = 'DNS'
    
    def __init__(self, *a, **kw):
        super(Dns, self).__init__(*a, **kw)

    def _host_cb(self, output, source):
        self.protocol.msg(source, output.strip())

    @usage('dns lookup <record>')
    def cmd_dns_lookup(self, source, record):
        """Perform a DNS lookup on <record>."""
        args = [record]

        # TODO: Support 'host -a' for a full listing
        #if all:
        #    args.insert(0, '-a')

        d = utils.getProcessOutput('host', args)
        d.addCallback(self._host_cb, source)

thisPlugin = Dns()
